#ifndef ADF_H_INCLUDED
#define ADF_H_INCLUDED

// Enable/Disable ADF Debuging
//#define DEBUG_ADF

// Maximum avaliable floppy drives
#define	MAX_FLOPPY_DRIVES		0x04

// floppy disk interface defs
#define CMD_RDTRK 0x01
#define CMD_WRTRK 0x02

// floppy status
#define DSK_INSERTED 0x01               /*disk is inserted*/
#define DSK_WRITABLE 0x10               /*disk is writable*/

#define MAX_TRACKS (83*2)

struct adfTYPE
{
    unsigned char status;               /*status of floppy*/
    unsigned char tracks;               /*number of tracks*/
    unsigned char track;                /*current track*/
    unsigned char sector;               /*current sector*/
    struct fileTYPE file;               /*file handle of inserted floppy*/
};

// Extern structs needed for other modules
extern struct adfTYPE *pdfx;			// drive select pointer
extern struct adfTYPE df[MAX_FLOPPY_DRIVES];	// drives information structure

void SendSector(unsigned char *pData, unsigned char sector, unsigned char track, unsigned char dsksynch, unsigned char dsksyncl);
void SendGap(void);
void SeekTrack(struct adfTYPE *drive, unsigned char track_step);
void ReadTrack(struct adfTYPE *drive);
unsigned char FindSync(struct adfTYPE *drive);
unsigned char GetHeader(unsigned char *pTrack, unsigned char *pSector);
unsigned char GetData(void);
void WriteTrack(struct adfTYPE *drive);
void UpdateDriveStatus(void);
void HandleFDD(unsigned char c1, unsigned char c2);
void InsertFloppy(struct fileTYPE *floppy, struct adfTYPE *drive);

#endif /*ADF_H_INCLUDED*/
